<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../">
  <title data-ice="title">public/js/toolkit/baseToolkit.js | archive-system-front-end</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
</head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/ArchiveSys/Web-Catalogue/archive-system-front-end.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js">js</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/moodral.js~moodral.html">moodral</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CONFIG">CONFIG</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge">js/catalouge</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System.js~Catalog_System.html">Catalog_System</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System_Base.js~Catalog_System_Base.html">Catalog_System_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-archive-connection">js/catalouge/Archive_Connection</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Archive_Connection/Archive_Connection.js~Archive_Connection.html">Archive_Connection</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry">js/catalouge/Catalog_Entry</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry.js~Catalog_Entry.html">Catalog_Entry</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js~Catalog_Entry_Base.html">Catalog_Entry_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry-moodral">js/catalouge/Catalog_Entry_Moodral</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry_Moodral/Catalog_Entry_Moodral.js~Catalog_Entry_Moodral.html">Catalog_Entry_Moodral</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-filter">js/catalouge/Filter</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter.js~Filter.html">Filter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter_Base.js~Filter_Base.html">Filter_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-page-headers">js/catalouge/Page_Headers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Page_Headers/Page_Headers.js~Page_Headers.html">Page_Headers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-toolkit">js/toolkit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/baseToolkit.js~toolkit.html">toolkit</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~baseStorageToolkitExtention.html">baseStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~permanentStorageToolkitExtention.html">permanentStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~sessionStorageToolkitExtention.html">sessionStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/contentToolkitExtention.js~contentToolkitExtention.html">contentToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/endlessScrollToolkitExtention.js~endlessScrollToolkitExtention.html">endlessScrollToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/eventToolkitExtention.js~eventToolkitExtention.html">eventToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/formToolkitExtention.js~formToolkitExtention.html">formToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/httpConnectionsToolkitExtention.js~httpConnectionsToolkitExtention.html">httpConnectionsToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/styleToolkitExtention.js~styleToolkitExtention.html">styleToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/urlToolkitExtention.js~urlToolkitExtention.html">urlToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-aggregator">aggregator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-NOTHING">NOTHING</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">public/js/toolkit/baseToolkit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">/* esversion: 6 */

/* &quot;I&apos;ll bould my own jQuery! Without bloat, and ES6 Compatable!&quot; */
/* Base toolkit class, contains all the selector code. */

/**
 * This combines classes into one.
 * @example class tk extends aggregator(toolkit, contentToolkitExtention, styleToolkitExtention, urlToolkitExtention) {};
 * @param {Class} baseClass - The base class.
 * @param {...Class} mixins - Classes to mix in.
 * @return {Class} mixed class
 */
export const aggregator = (baseClass, ...mixins) =&gt; {
  let base = class _Combined extends baseClass {
    constructor (...args) {
      super(...args)
      mixins.forEach((mixin) =&gt; {
        mixin.prototype.initializer.call(this)
      })
    }
  }
  let copyProps = (target, source) =&gt; {
    Object.getOwnPropertyNames(source)
      .concat(Object.getOwnPropertySymbols(source))
      .forEach((prop) =&gt; {
        if (prop.match(/^(?:constructor|prototype|arguments|caller|name|bind|call|apply|toString|length)$/))
          return
            Object.defineProperty(target, prop, Object.getOwnPropertyDescriptor(source, prop))
      })
  }
  mixins.forEach((mixin) =&gt; {
    copyProps(base.prototype, mixin.prototype)
    copyProps(base, mixin)
  })
  return base
}

/**
 * This is the base toolkit, all extentions are built off of this one.
 * @example let tk = new toolkit(&quot;body&quot;);
 * @see https://gitlab.com/Jcc10/JS-Toolkit
 */
export class toolkit{

    /**
     * Preforms the initial search.
     * @param {DOMString} [cssSearch] - The CSS you are searching for.
     * @param {Element} [baseElement=document] - the base element to start from
     * @param {boolean} [errorOnEmpty=false] - if a error should be thrown if no elements were selected when one needed to be.
     */
    constructor(cssSearch, baseElement, errorOnEmpty) {
      /**
       * Extentions in the current toolkit (and the order they were loaded).
       * @private
       * @type {String[]}
       */
      this.extentions = [&quot;baseToolkit&quot;];

      /**
       * If there are elements currently selected.
       * @protected
       * @type {boolean}
       */
      this.ele = false;

      /**
       * The elements currently selected.
       * @protected
       * @type {Array&lt;Element&gt;}
       */
      this.elements = [];

      /**
       * Error constants
       * @public
       * @type {ENUM}
       */
      this.ERRORS = {
        NO_ELEMENTS: &quot;No Elements Selected&quot;,
        MISSING_REQUIREMENT: &quot;Missing A Required Prerequisite Extention&quot;,
        INVALID_ENUM: &quot;A Invalid ENUM was provided&quot;,
        INVALID_ELEMENT_COUNT: &quot;A invalid count of selected elements were selected for the current function.&quot;
      }

      errorOnEmpty = errorOnEmpty || false;
      /**
       * If a error should be thrown when there are no elements to itterate through and elements are required for the operation.
       * @public
       * @type {boolean}
       */
      this.errorOnEmpty = errorOnEmpty;

      baseElement = baseElement || document;
      /**
       * If a error should be thrown when there are no elements to itterate through and elements are required for the operation.
       * @public
       * @type {Element}
       */
      this.baseElement = baseElement;

      // run the base search.
      this.searchBase(cssSearch);
    }

    /**
     * Adds extention to the extentions member.
     * @protected
     * @param {String} newExtention - the new extention to add to the array.
     */
    addExtention(newExtention){
      this.extentions.push(newExtention);
    }

    /**
     * Ensures a extention has already been loaded.
     * @protected
     * @param {String} requiredExtention - the extention that must already be in the toolkit.
     * @throws {this.ERROR.MISSING_REQUIREMENT}
     */
    requireExtention(requiredExtention){
      if(!(this.extentions.includes(requiredExtention))) {
        throw this.ERRORS.MISSING_REQUIREMENT;
      }
    }

    /**
     * Get&apos;s all current extentions.
     * @public
     * @return {String[]} all current extentions.
     */
    getExtentions(){
      return this.extentions;
    }

    /**
     * Checks to see if there are elements in the system.
     *
     * If there is not and it&apos;s set to throw errors, then it throws a error.
     * If there is not but it&apos;s not set to throw errors, it fails silently.
     * @throws {this.errors.NO_ELEMENTS} no elements when elements are required.
     * @public
     */
    hasElement(){
      if(!(this.ele) &amp;&amp; this.errorOnEmpty) {
        throw this.errors.NO_ELEMENTS;
      }
    }

    /**
     * Updates the ele member.
     * @protected
     */
    updateEle(){
      if(this.elements.length &gt; 0){
        this.ele = true;
      } else {
        this.ele = false;
      }
    }

    /**
     * Does a function on each element.
     * @public
     * @param {function} f - function to run on each element
     */
    doEach(f) {
      this.hasElement();
      this.elements.forEach(f);
    }

    /**
     * Returns this object&apos;s elements.
     * @public
     * @return {Array&lt;Elements&gt;}
     */
    getElements(){
      return this.elements;
    }

    /**
     * Imports elements from another toolkit.
     * @public
     * @param {toolkit} otherToolkit - the toolkit to import from.
     */
    importElementsFromToolkit(otherToolkit) {
      this.elements = otherToolkit.getElements;
      this.updateEle();
    }

    /**
     * Switches all elements to the parrents of the old list.
     * @public
     */
    parrents() {
      this.hasElement();
      let newElements = [];
      this.doEach((oldElement, index) =&gt; { newElements.push(oldElement.parentElement); });
      this.elements = newElements;
      this.updateEle();
    }

    /**
     * Searches current element list for new elements useing a CSS selector or Removes all CSS selectors.
     * @public
     * @param {DOMString} [cssSearch] - css to search for
     */
    searchChildren(cssSearch) {
      this.hasElement();
      if (cssSearch !== null){
        let newElements = [];
        let f = function(oldElement, index){
          newElements = newElements.concat(
              Array.prototype.slice.call(
                  oldElement.querySelectorAll(cssSearch)
                )
            );
        }
        this.doEach(f);
        this.elements = newElements;
        this.updateEle();
      } else {
        this.ele = false;
        this.elements = [];
      }
    }

    /**
     * Searches from the base Element for the CSS selector or Removes all selected elements.
     * @public
     * @param {DOMString} [cssSearch] - css to search for
     */
    searchBase(cssSearch) {
      if (cssSearch !== null){
        this.elements = this.baseElement.querySelectorAll(cssSearch);
        this.updateEle();
      } else {
        this.ele = false;
        this.elements = [];
      }
    }

}
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
